controllers/SiteController.php
<?php

namespace app\controllers;
use yii\data\SqlDataProvider;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;
use yii\data\ActiveDataProvider;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /*
     * Creado esta accion
     */
    
    public function actionCrud(){
        return $this->render('gestion');
    }
    
 
    public function actionConsulta1a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("COUNT(*) AS nciclistas"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT COUNT(*) AS nciclistas FROM ciclista",
        ]);
    }
    
    public function actionConsulta1(){
            // mediante DAO
        
        $dataProvider= new SqlDataProvider([
            'sql'=> 'SELECT COUNT(*) AS nciclistas FROM ciclista' ,
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT COUNT(*) AS nciclistas FROM ciclista",
        ]);
                
    }
    
    public function actionConsulta2a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("COUNT(*) AS nciclistas")->distinct()->where("nomequipo='banesto'"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Número de ciclistas que hay en el equipo Banesto",
            "sql"=>"SELECT COUNT(*) AS nciclistas FROM ciclista WHERE nomequipo='banesto'",
        ]);
    }
    
     public function actionConsulta2(){
            // mediante DAO
        
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT COUNT(*) AS nciclistas FROM ciclista WHERE nomequipo='banesto'" ,
                'pagination'=>[
                'pageSize'=>0,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Número de ciclistas que hay en el equipo Banesto",
            "sql"=>"SELECT COUNT(*) AS nciclistas FROM ciclista WHERE nomequipo='banesto'",
        ]); 
        
    }
    
    public function actionConsulta3a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("avg(edad) edadMedia"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edadMedia'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"La edad media de los ciclistas",
            "sql"=>"SELECT avg(edad) edadMedia FROM ciclista",
        ]);
    }
    
     public function actionConsulta3(){
            // mediante DAO
               
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT avg(edad) edadMedia FROM ciclista" ,
                'pagination'=>[
                'pageSize'=>0,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edadMedia'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"La edad media de los ciclistas",
            "sql"=>"SELECT avg(edad) edadMedia FROM ciclista",
        ]); 
    }
    
    public function actionConsulta4a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("avg(edad) edadMedia")
                ->where("nomequipo='Banesto'"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edadMedia'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"La edad media de los ciclistas de Banesto",
            "sql"=>"SELECT avg(edad) edadMedia FROM ciclista WHERE nomequipo='Banesto'",
        ]);
    }
    
     public function actionConsulta4(){
            // mediante DAO
        
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT avg(edad) edadMedia FROM ciclista WHERE nomequipo='Banesto'" ,
        
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edadMedia'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"La edad media de los ciclistas de Banesto",
            "sql"=>"SELECT avg(edad) edadMedia FROM ciclista WHERE nomequipo='Banesto'",
        ]);
    }
    
       public function actionConsulta5a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("nomequipo, avg(edad) edadMedia")
                ->groupBy("nomequipo"),
            'pagination'=>[
                'pageSize'=>5,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nomequipo','edadMedia'],
            "titulo"=>"Consulta 5",
            "enunciado"=>"La edad media de los ciclists por cada equipo",
            "sql"=>"SELECT nomequipo, avg(edad) edadMedia FROM ciclista GROUP BY nomequipo",
        ]);
    }
    
     public function actionConsulta5(){
            // mediante DAO
        
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT nomequipo, avg(edad) edadMedia FROM ciclista GROUP BY nomequipo" ,
        
            'pagination'=>[
                'pageSize'=>5,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nomequipo','edadMedia'],
            "titulo"=>"Consulta 5",
            "enunciado"=>"La edad media de los ciclists por cada equipo",
            "sql"=>"SELECT nomequipo, avg(edad) edadMedia FROM ciclista GROUP BY nomequipo",
        ]);
    } 
    
     public function actionConsulta6a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("nomequipo, count(*) nciclistas")
                ->groupBy("nomequipo"),
            'pagination'=>[
                'pageSize'=>30,
                ]
        ]);
                
          return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nomequipo','nciclistas'],
            "titulo"=>"Consulta 6",
            "enunciado"=>"El número de ciclistas por equipo",
            "sql"=>"SELECT nomequipo, count(*) nCiclistas  FROM ciclista GROUP BY nomequipo",
        ]);
    }
    
     public function actionConsulta6(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT count(*) FROM ciclista GROUP BY nomequipo" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT nomequipo, count(*) nciclistas  FROM ciclista GROUP BY nomequipo" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>30,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nomequipo','nciclistas'],
            "titulo"=>"Consulta 6",
            "enunciado"=>"Listar el numero de ciclistas por equipo",
            "sql"=>"SELECT nomequipo, count(*) nCiclistas  FROM ciclista GROUP BY nomequipo",
        ]);
    } 
    
    
    public function actionConsulta7a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php

use yii\helpers\Html;

echo Html::a('Ciclistas',
        ['ciclista/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Etapas',
        ['etapa/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Equipos',
        ['equipo/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Lleva',
        ['lleva/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Maillot',
        ['maillot/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Puerto',
        ['puerto/index'],
        ['class' => 'btn btn-primary btn-large']
        );



?>

views/site/index.php
<?php
use yii\bootstrap\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>

<div class="site-index">

    <div class="jumbotron">
        <h1>consultas de seleccion 2</h1>
Application
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">

        <div class="row">
            <!-- primera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 1</h3>
                      <p>Número de ciclistas que hay</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta1a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta1'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
            <!-- segunda consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 2</h3>
                      <p>Número de ciclistas que hay en el equipo Banesto</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta2a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta2'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             <!-- tercera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 3</h3>
                      <p>La edad media de los ciclistas</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             
              <!-- cuarta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 4</h3>
                      <p>La edad media de los ciclistas de Banesto</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
               <!-- quinta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 5</h3>
                      <p>La edad media de los ciclists por cada equipo</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta5a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta5'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
               <!-- sexta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 6</h3>
                      <p>El número de ciclistas por equipo</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta6a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta6'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
               
              <!-- septima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 7</h3>
                      <p>El número total de puertos</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta7a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta7'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- octava consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 8</h3>
                      <p>El número total de puertos mayores de 1500</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- novena consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 9</h3>
                      <p>Listas nombre de los equipos de mas de 4 ciclistas</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta9a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta9'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- decima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 10</h3>
                      <p>Listar el nombre de los equipos que tengan más de 4 ciclistas cuya edad este entre 28 y 32</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta10a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta10'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              <!-- undecima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 11</h3>
                      <p>Indícame el número de etapas que ha ganado cada uno de los ciclistas</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta11a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta11'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- duodecima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 12</h3>
                      <p>Indícame el dorsal de los ciclistas que hayan ganado más de 1 etapa</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta12a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta12'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
        </div>

    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>


 <div class="jumbotron">
        <h1><?= $titulo?></h1>
        <p class="lead"><?=$enunciado?></p>
            <div class="well"> 
            <?= $sql?>
            </div>
    </div>
    
    
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
                
    ]);?>